HDU1394 Minimum Inversion Number 线段树+数学

Problem Description

The inversion number of a given number sequence a1, a2, …, an is the number of pairs (ai, aj) that satisfy i < j and ai > aj.

For a given sequence of numbers a1, a2, …, an, if we move the first m >= 0 numbers to the end of the seqence, we will obtain another sequence. There are totally n such sequences as the following:

a1, a2, …, an-1, an (where m = 0 - the initial seqence)

a2, a3, …, an, a1 (where m = 1)

a3, a4, …, an, a1, a2 (where m = 2)

an, a1, a2, …, an-1 (where m = n-1)

You are asked to write a program to find the minimum inversion number out of the above sequences.

Input

The input consists of a number of test cases. Each case consists of two lines: the first line contains a positive integer n (n <= 5000); the next line contains a permutation of the n integers from 0 to n-1.

Output

For each case, output the minimum inversion number on a single line.

Sample Input

10

1 3 6 9 0 8 5 7 4 2

Sample Output

16

解题思路

这题折腾了一晚上才AC 还是太粗心了。

因为数据小,貌似暴力也是可以过的。用线段树当然更好。

解题分为两步

①先不考虑移动,用O(nlogn)把初始的逆序对个数算出来(假设是sum)

②用数学公式用O(1)递推sum 找到最小情况的sum

先看第一步,用线段树。每读入一个数我们只考虑在它之前已经读入的数。便于统计我们将所有的s[i]++成为1-n的正整数。再看当前读入的这个数和n之间的这一段距离已经存在了几个数。他们就是当前这个数的”前瞻逆序对”

第二步。假设当前逆序对是sum个。现在考虑第一个数 假设是k 将它放到队伍的最后面。我们知道在第2到第n个数中有k-1个是小于k的,n-k个是大于k的。所以这么一移动,自然逆序对数量就少了k-1个,多了n-k个。这样不断循环,不断更新最小值。

代码

#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
const int maxn = 5010;
int n;
int s[maxn];
int ans[maxn];
int segTree[maxn<<2];
void update(int node,int k,int l,int r)
{
    if(l <= k && k <= r) segTree[node] ++;
    if(l == r) return;
    if(r < k || l > k) return;
    update(node<<1,k,l,(l+r)/2);
    update((node<<1)+1,k,(l+r)/2+1,r);
}
int query(int a,int b,int node,int l,int r)
{
    if(l > b || r < a) return 0;
    if(a <= l && r <= b) return segTree[node];
    return query(a,b,node<<1,l,(l+r)/2)+query(a,b,(node<<1)+1,(l+r)/2+1,r);
}
int main()
{
    while(scanf("%d",&n) != EOF) {
        memset(s,0,sizeof(s));
        memset(ans,0,sizeof(ans));
        memset(segTree,0,sizeof(segTree));
        for(int i = 1 ; i <= n ; i ++) {
            scanf("%d",&s[i]);
            s[i] ++;
            ans[i] = query(s[i],n,1,1,n);
            update(1,s[i],1,n);
        }
        int sum = 0;
        for(int i = 1 ; i <= n ; i ++) sum += ans[i];
        int mi = sum;
        for(int i = 1 ; i < n ; i ++) {
            sum = sum+1+n-2*s[i];
            if(sum < mi) mi = sum;
        }
        printf("%d\n",mi);
    }
    return 0;
}
时间: 2024-10-13 20:51:46

HDU1394 Minimum Inversion Number 线段树+数学的相关文章

hdu1394 Minimum Inversion Number(线段树单点更新||暴力)

题目链接: huangjing 这个题目暴力和线段树都可以过,但是都需要掌握一个规律.. 当队首元素移到队尾后,可定会减少a[i]个逆序对,然后增加n-1-a[i]个逆序对. 你看比如1移到队尾,那么1>0这个逆序对就会减少,2>1,3>1,4>1这些逆序对就会增加.. 所以发现这个规律就好做了.. 暴力做法就是直接那样模拟.. 线段树做法是首先建立一颗空树,然后插入之前询问这颗树中在[插入元素,n]之间的树,求出来的就是逆序对的个数.然后将其更新进去即可.. 题目: 寻人启事:2

hdu1394 Minimum Inversion Number 线段树和树状数组

题意: 输入一个长度 n 第二行给出长度为n的数组,数组的值刚好为0到n-1这n个数. 然后每次把数组的第一个数放到最后一个,放n-1次,共有n个排列,这n个排列就有n个逆序数,输出这n个逆序数的最小值. 我的做法: 1.每次输入a[i]后,都把a[i] ++; 2.求出第一个排列的逆序数 3.递推求出所有的逆序数 那怎么求1呢? 对于每一个a[i],求出1到i-1 中比它大的个数,然后相加,即可得.若用朴素的查找,肯定会超时的,所以这里就利用线段树或者树状数组来快速查找. 线段树版本: 1 #

Minimum Inversion Number(线段树单点更新+逆序数)

Minimum Inversion Number(线段树单点更新+逆序数) Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy

hdu 1394 Minimum Inversion Number 线段树 点更新

// hdu 1394 Minimum Inversion Number 线段树 点更新 // // 典型线段树的单点更新 // // 对于求逆序数,刚开始还真的是很年轻啊,裸的按照冒泡排序 // 求出最初始的逆序数,然后按照公式递推,结果就呵呵了 // // 发现大牛都是用线段树和树状数组之类的做的,而自己又在学 // 线段树,所以就敲了线段树. // // 线段树的节点保存一段区间( L,R )内0,1...n一共出现了多少个. // 因为每个数是0,1,2...n-1且没有重复的数字. /

HDU 1394 Minimum Inversion Number.(线段树)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1394 ~~~~ 早起一发线段树,开心又快乐.这题暴力也能水过,同时线段树的效率也就体现的尤为明显了,看了大牛的博客,说是还可以用树状数组,点树和合并序列写,现在还不懂,留着以后在写吧. ~~~~ 大致题意:给定一个数字序列,同时由此可以得到n个序列, 要求从n个序列中找到逆序数最小的序列,输出最小逆序数. 首先介绍下逆序数的概念: 在一个排列中,如果一对数的前后位置与大小顺序相反,即前面的数大于后面

HDU 1394 Minimum Inversion Number (线段树,单点更新)

C - Minimum Inversion Number Crawling in process... Crawling failed Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Practice HDU 1394 Appoint description: System Crawler (2015-08-17) Description The inversio

Hdu 1394 Minimum Inversion Number(线段树或树状数组)

Minimum Inversion Number Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 11981    Accepted Submission(s): 7321 Problem Description The inversion number of a given number sequence a1, a2, ..., a

HDU 1394 Minimum Inversion Number (线段树,暴力)

Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj. For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the seq

hdu 1394 Minimum Inversion Number 线段树

Problem Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj. For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of